module Mirror_Col(	//	Input Side
					iCCD_R,
					iCCD_G,
					iCCD_B,
					iCCD_DVAL,
					iCCD_PIXCLK,
					iRST_N,
					//	Output Side
					oCCD_R,
					oCCD_G,
					oCCD_B,
					oCCD_DVAL	);
//	Input Side					
input	[9:0]	iCCD_R;
input	[9:0]	iCCD_G;
input	[9:0]	iCCD_B;
input			iCCD_DVAL;
input			iCCD_PIXCLK;
input			iRST_N;
//	Output Side
output	[9:0]	oCCD_R;
output	[9:0]	oCCD_G;
output	[9:0]	oCCD_B;
output			oCCD_DVAL;
//	Internal Registers
reg		[9:0] mCCD_R;
reg		[9:0] mCCD_G;
reg		[9:0] mCCD_B;

reg		[9:0]	Z_Cont;
reg				mCCD_DVAL;

// Temp stuff
wire		[9:0] tCCD_R;
wire		[9:0] tCCD_G;
wire		[9:0] tCCD_B;

assign	oCCD_R		=  mCCD_R;
assign	oCCD_G		=  mCCD_G;
assign	oCCD_B		=  mCCD_B;
assign	oCCD_DVAL	=	mCCD_DVAL;

always@(posedge iCCD_PIXCLK or negedge iRST_N)
begin
	if(!iRST_N)
	begin
		mCCD_DVAL	<=	0;
		Z_Cont		<=	0;
	end
	else
	begin
		/*if(Z_Cont>150 &&Z_Cont < 450)
		begin*/
			mCCD_R <= tCCD_R;
			mCCD_G <= tCCD_G;
			mCCD_B <= tCCD_B;
		/*end
		else
		begin
			mCCD_R <= 0;
			mCCD_G <= 0;
			mCCD_B <= 0;
		end*/
		mCCD_DVAL	<=	iCCD_DVAL;
		if(Z_Cont<640)
		begin
			if(iCCD_DVAL)
			Z_Cont	<=	Z_Cont+1'b1;
		end
		else
		Z_Cont	<=	0;
	end
end

Stack_RAM ram1(
			.clock(iCCD_PIXCLK),
			.data(iCCD_R),
			.rdaddress(639-Z_Cont),
			.wraddress(Z_Cont),
			.wren(iCCD_DVAL),
			.q(tCCD_R));

Stack_RAM ram2(
			.clock(iCCD_PIXCLK),
			.data(iCCD_G),
			.rdaddress(639-Z_Cont),
			.wraddress(Z_Cont),
			.wren(iCCD_DVAL),
			.q(tCCD_G));

Stack_RAM ram3(
			.clock(iCCD_PIXCLK),
			.data(iCCD_B),
			.rdaddress(639-Z_Cont),
			.wraddress(Z_Cont),
			.wren(iCCD_DVAL),
			.q(tCCD_B));

endmodule